/******************************************************************************
 $Header:: /MewAddOn/Multi Edit/DFConfig.s 12    2-02-98 22:01 Gerard         $

 Copyright (c) 1997 G.J. Wijnands. All rights reserved.

														MULTI-EDIT MACRO FILE

 Name:   `name`

 Description:  `description`

******************************************************************************/
macro_file DFCONFIG;

// MEW
#include DIALOG.SH
#include WIN32.SH

// Add-on
#include DFREG.SH
#include DATAFLEX.SH

#define gsSELECTNONE "<none>"

#define id_Language_Static     1100
#define id_Language_Choice     1101

#define id_Inherit_Static      1102
#define id_Inherit_Text        1103

#define id_DFPath_Static       1104
#define id_DFPath_Text         1105
#define id_MakePath_Static     1106
#define id_DFProg_Static       1108
#define id_DFEnv_Static        1110
#define id_Home_Static         1112
#define id_DFComp_Static       1114
#define id_DFComp_Text         1115
#define id_Searchstring_Static 1116
#define id_Explorer_Static     1118
#define id_DFFile_Static       1120
#define id_DFIndex_Static      1122
#define id_DFMaint_Static      1124
#define id_AppBuilder_Static   1126

#define id_Workspace_Static    1128
#define id_Workspace_Text      1129
#define id_MainApp_Static      1130
#define id_MainApp_Text        1131

#define id_ParenHiCB      1100
#define id_KeywordHiCB    1101


/********************************************************************
                                                       Multi-Edit Macro
                                                         22-1-98 21:36

  Function: This function returns the <iChoice> choise from <sChoice>.
  Entry   : iChoice - the number of the choice
            sChoice - All choices separated with '()'
  Exit    : The string which was chosen.

***********************************************************************/
str GetChoiceString( int iChoice, str sChoices )
{
  int iIndex, iPos;
      
  iIndex = iChoice;
  iPos = 1;
  while ( --iIndex ) iPos = xPos( '()', sChoices, iPos + 1 );
  if ( iPos == 1 ) iPos -= 2;
  return ( Copy( sChoices, iPos + 2, xPos( '()', sChoices, iPos + 3 ) - iPos - 2 ) );

}  // GetChoiceString

/********************************************************************
                                                       Multi-Edit Macro
                                                         24-1-98 19:02

  Function: This function returns the index of sChoice in sChoices.
  Entry   : sChoices - a list of possible choices
            sChoice  - one choice
  Exit    : the index of sChoice in sChoice

                                    Copyright 1998 By Gerard J Wijnands
***********************************************************************/
int GetChoiceInt( str sChoices, str sChoice )
{
  int iIndex, iChoicePos, iPos;
  str sCapsChoices[ max_line_length ];
  str sCapsChoice[ max_line_length ];

  sCapsChoices = Caps( sChoices );
  sCapsChoice  = Caps( sChoice  ) + "()";
  
  // ---------------------------------------------------------------------
  // Check if it is the first...
  // 
  if ( Copy( sCapsChoices, 1, Length( sCapsChoice )) == sCapsChoice) {
    iIndex = 1;
  }
  else {
    // -------------------------------------------------------------------
    // Check if the choice is in the list of choices...
    // 
    if (( iChoicePos = XPos( "()" + sCapsChoice, sCapsChoices, 1 )) == 0) {
      iIndex = 0;
    }
    else {
      // -----------------------------------------------------------------
      // Walk through the choices until the correct choice has been found.
      // 
      iIndex = 2;
      iPos = 0;
      while ((iPos = XPos( "()", sCapsChoices, iPos + 1 )) < iChoicePos) iIndex++;
    }
  }
  return ( iIndex );
}  // GetChoiceInt

/******************************************************************************
															 Multi-Edit Macro
                               02-Oct-97  19:22

  Function: Adds a pulldown menu to the dialog.

  Entry   : iDlg        - the dialog handle
            sText       - The text for the user
            iCtrlID     - the control ID
            sChoices    - the possible choices
            sFolder     - the folder or subkey where the values is stored
            sRegKey     - the key where the value comes from
            iXOffset    - the X offset
            iYOffset    - the Y offset

  Exit    : none

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void DFAddCtrlChoice( int iDlg, str sText, int iCtrlID, str sChoices,
                      str sFolder, str sRegKey, int iXOffset, int iYOffset )
{
  int iOffset, iChoice;

  if ( iXOffset < 0 ) iOffset = dlg_NegOffset - iXOffset;
  else iOffset = dlg_PosOffset + iXOffset;

  iChoice = GetChoiceInt( sChoices, GetStringFromRegistry( sFolder, sRegKey ));

  DlgAddCtrl( iDlg, Dlg_STATIC, sText,
      iOffset, dlg_PosOffset + iYOffset,
      0, 0,
      iCtrlID, 0, "" );

  DlgAddCtrl( iDlg, Dlg_Choice, sChoices,
      dlg_PosOffset + 14, dlg_PosOffset,
      50, 0,
      iCtrlID + 1, 0, "" );
  DlgSetInt( iDlg, iCtrlID + 1, iChoice );

}  // DFAddCtrlChoice  

/******************************************************************************
															 Multi-Edit Macro
															 20-Oct-95  15:47

	Function: Show the a sample of the indent selected indent style.  Only to be
						called by the CSetProperties macro. ( Internal Function )

	Entry   : int Dlg			- The data handle for the Properties dialog
	Exit    : None

							 Copyright (C) 1997 by G.J. Wijnands.
********************************************************************( ldh )***/
void CBChange( int iDlg    = Parse_Int( "/DATAHANDLE=", MParm_Str ),
	             int iCtrlID = Parse_Int( "/CTRLID="    , MParm_Str )  )
{
	if ( iDlg ) {

    DlgSetFields( iDlg );
    // Enable the text if the checkbox is true, disable it if the checkbox is false.
		if (( iCtrlID >= id_DFPath_Static) && ( iCtrlID <= id_AppBuilder_Static ))
		{
	    DlgEnableCtrl( iDlg, iCtrlID+1, DlgGetInt( iDlg, iCtrlID ) );
		}
	}

}  // CBChange

void CBVDFChangeAll( int iDlg = Parse_Int( "/DATAHANDLE=", MParm_Str ) )
{
	int i;
  for ( i=id_DFComp_Static; i <= id_AppBuilder_Static; i+=2 )
	{
		CBChange( iDlg, i );
	}
}  // CBVDFChangeAll

void CBChangeAll( int iDlg = Parse_Int( "/DATAHANDLE=", MParm_Str ) )
{
	int i;
	for ( i=id_DFPath_Static; i <= id_AppBuilder_Static; i+=2 )
	{
		CBChange( iDlg, i );
	}
}  // CBChangeAll

/******************************************************************************
															 Multi-Edit Macro
                               28-Sep-97  20:55

  Function: Processes the value of the checkbox and the value into the registry.

  Entry   : iDlg        - the dialog handle
            sFolder     - the folder or subkey where the values must be stored
            sKey        - the key which must be filled
            iCheckBoxID - the ID of the control in the dialog which represents the checkbox
            iValueID    - id. of the textfield.

  Exit    : none

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void ProcessValue( int iDlg, str sFolder, str sKey, int iCheckBoxID );
{
  if ( DlgGetInt( iDlg, iCheckBoxID ) )
  {
    SetKeyFromRegistry( sFolder, sKey, DlgGetStr( iDlg, iCheckBoxID + 1) );
  }
  else
  {
    DeleteKeyFromRegistry( sFolder, sKey );
  }
} // ProcessValue

/******************************************************************************
															 Multi-Edit Macro
                               02-Oct-97  19:22

  Function: Adds a CbeckBox and a TextBox to the dialog, so that the checkbox
            controls whether the text can be entered or not.

  Entry   : iDlg        - the dialog handle
            sText       - The text for the user
            iCtrlID     - the control ID
            sFolder     - the folder or subkey where the values is stored
            sRegKey     - the key where the value comes from
            iXOffset    - the X offset
            iYOffset    - the Y offset

  Exit    : none

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void DFAddCtrlCBTB( int iDlg, str sText, int iCtrlID, str sFolder, str sRegKey, int iXOffset, int iYOffset )
{
  int iOffset, bOn;
  str sValue[ max_line_length ];

  sValue = GetStringFromRegistry( sFolder, sRegKey );
  bOn = ( iRegError == giREGSUCCESS );
//  if ( !bOn ) {
//    sValue = "Hoi"; //GetSessionSettingRecursively( sFolder, sRegKey );
//  }

  if ( iXOffset < 0 ) iOffset = dlg_NegOffset - iXOffset;
  else iOffset = dlg_PosOffset + iXOffset;

  DlgAddCtrl( iDlg, Dlg_CHECKBOX, sText,
      iOffset, dlg_PosOffset + iYOffset,
      0, 0,
      iCtrlID, 0, "/CHANGEMAC=CBCHANGE" );

  DlgAddCtrl( iDlg, Dlg_TEXT, sValue,
      dlg_PosOffset + 14, dlg_PosOffset,
      50, 0,
      iCtrlID + 1, 0, "/ML=" + str(max_line_length) );
  DlgSetInt( iDlg, iCtrlID, bOn );
}  // DFAddCtrlCBTB

/******************************************************************************
															 Multi-Edit Macro
                               02-Oct-97  19:22

  Function: Adds a TextBox to the dialog.

  Entry   : iDlg        - the dialog handle
            sText       - The text for the user
            iCtrlID     - the control ID
            sFolder     - the folder or subkey where the values is stored
            sRegKey     - the key where the value comes from
            iXOffset    - the X offset
            iYOffset    - the Y offset

  Exit    : none

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void DFAddCtrlTB( int iDlg, str sText, int iCtrlID, str sFolder, str sRegKey, int iXOffset, int iYOffset )
{
  int iOffset;

  if ( iXOffset < 0 ) iOffset = dlg_NegOffset - iXOffset;
  else iOffset = dlg_PosOffset + iXOffset;

  DlgAddCtrl( iDlg, Dlg_STATIC, sText,
      iOffset, dlg_PosOffset + iYOffset,
      0, 0,
      iCtrlID, 0, "" );

  DlgAddCtrl( iDlg, Dlg_TEXT, GetStringFromRegistry( sFolder, sRegKey ),
      dlg_PosOffset + 14, dlg_PosOffset,
      50, 0,
      iCtrlID + 1, 0, "/ML=" + str(max_line_length) );
}  // DFAddCtrlTB

void DFAddButtons( int iDlg, int bCancel )
{
  DlgAddCtrl( iDlg, dlg_PushButton, "OK",
			1, dlg_PosOffset | dlg_Units | dlg_Units | ( dlg_Units_HLine * 3 ),
			dlg_StanBtnWidth, 0,
			2001, dlgf_DefButton, "/R=1" );

  if ( bCancel ) {
    DlgAddCtrl( iDlg, dlg_PushButton, "Cancel",
        dlg_PosOffset + dlg_StanBtnWidth + 2, dlg_PosOffset + 0,
        dlg_StanBtnWidth, 0,
        2000, 0, "/R=0" );
  }

  DlgAddCtrl( iDlg, dlg_PushButton, "&Help",
			dlg_PosOffset + dlg_StanBtnWidth + 2, dlg_PosOffset + 0,
			dlg_StanBtnWidth, 0,
			2002, 0, "/R=2" );

}  // DFAddButtons

void ConfigureVDF( int bSession, str sLanguage, str sFolder );
{
  int Dlg, iStartCtrlID, iYBox;
  str sTitle, sHelpTopic, sValue;
  str sChoiceInherit[ max_line_length ], sChoiceWorkspace[ max_line_length ],
      sChoiceMainApp[ max_line_length ];

  if ( bSession )
  {
    sTitle = "DataFlex session setup - " + sFolder;
    iStartCtrlID = id_Inherit_Static;
    sChoiceInherit   = gsSELECTNONE + "()" + GetSubkeys( gsREGFLDROOT + gsREGFLDPROJECTS, TRUE, ","+Caps(sFolder)+"," );
    sChoiceWorkspace = gsSELECTNONE + "()" + GetSubkeys( gsWorkSpacesKey, TRUE );
    sChoiceMainApp   = gsSELECTNONE + "()" + GetSubkeys( gsMainAppKey, TRUE, gsMainAppSkip );
    sFolder = gsREGFLDPROJECTS + sFolder;
  }
  else
  {
    sTitle = "DataFlex version setup - " + sFolder;
    iStartCtrlID = id_DFComp_Static;
    sFolder = gsREGFLDLANGUAGES + sFolder;
  }

  sHelpTopic = gsHELPPATH + "MEW_DF^";
  if ( bSession)
  {
    sHelpTopic += "Current Session (VDF)";
  }
  else
  {
    sHelpTopic += "Visual DataFlex";
  }

  DlgCreate( Dlg );

  if ( bSession )
  {
    DlgAddCtrl( Dlg, dlg_GroupBox, "", 1, 1, 67, DLG_Units + (3 * dlg_Units_Per_Line) + 8 , -1, 0, "" );
    DFAddCtrlChoice( Dlg, "Inherit from", id_Inherit_Static  , sChoiceInherit  , sFolder, gsREGINHERIT  ,   1, 7 + DLG_Units );
    DFAddCtrlChoice( Dlg, "Workspace"   , id_Workspace_Static, sChoiceWorkspace, sFolder, gsREGWORKSPACE, -14, 1  );
    DFAddCtrlChoice( Dlg, "Main applic" , id_MainApp_Static  , sChoiceMainApp  , sFolder, gsREGMAINAPP  , -14, 1  );
    iYBox = 5;
  }
  else iYBox = 1;

  // Other settings
  DlgAddCtrl( Dlg, dlg_GroupBox, "", 1, iYBox, 67, DLG_Units + (6 * dlg_Units_Per_Line) + 8 , -1, 0, "" );

  DFAddCtrlCBTB( Dlg, "DFComp"    , id_DFComp_Static    , sFolder, gsREGDFCOMP    ,   1, 7 + DLG_Units );
  DFAddCtrlCBTB( Dlg, "Explorer"  , id_Explorer_Static  , sFolder, gsREGEXPLORER  , -14, 1 );
  DFAddCtrlCBTB( Dlg, "DFIndex"   , id_DFIndex_Static   , sFolder, gsREGDFINDEX   , -14, 1 );
  DFAddCtrlCBTB( Dlg, "DFFile"    , id_DFFile_Static    , sFolder, gsREGDFFILE    , -14, 1 );
  DFAddCtrlCBTB( Dlg, "DFMaint"   , id_DFMaint_Static   , sFolder, gsREGDFMAINT   , -14, 1 );
  DFAddCtrlCBTB( Dlg, "AppBuilder", id_AppBuilder_Static, sFolder, gsREGAPPBUILDER, -14, 1 );
      
  // Buttons
  DFAddButtons( Dlg, TRUE );

  int Result = DlgExecute( Dlg, iStartCtrlID + 1, sTitle , sHelpTopic, "/INITMAC=CBVDFCHANGEALL", 0 );
  Return_Int = 0;
	if ( Result ) {

    // Only sessions can set the inherit and workspace property
    if ( bSession )
    {
      sValue = DlgGetStr( dlg, id_Inherit_Text );
      if ( sValue == gsSELECTNONE) {
        sValue = "";
      }
      SetKeyFromRegistry( sFolder, gsREGINHERIT, sValue);

      sValue = DlgGetStr( dlg, id_Workspace_Text);
      if ( sValue == gsSELECTNONE) {
        sValue = "";
      }
      SetKeyFromRegistry( sFolder, gsREGWORKSPACE, sValue );
      
      sValue = DlgGetStr( dlg, id_MainApp_Text);
      if ( sValue == gsSELECTNONE) {
        sValue = "";
      }
      SetKeyFromRegistry( sFolder, gsREGMAINAPP, sValue );
    }

    ProcessValue( Dlg, sFolder, gsREGDFCOMP    , id_DFComp_Static    );
    ProcessValue( Dlg, sFolder, gsREGEXPLORER  , id_Explorer_Static  );
	  ProcessValue( Dlg, sFolder, gsREGDFINDEX   , id_DFIndex_Static   );
  	ProcessValue( Dlg, sFolder, gsREGDFFILE    , id_DFFile_Static    );
  	ProcessValue( Dlg, sFolder, gsREGDFMAINT   , id_DFMaint_Static   );
  	ProcessValue( Dlg, sFolder, gsREGAPPBUILDER, id_AppBuilder_Static);

    RefreshSettings();
	}
  DlgKill( Dlg );

}  // ConfigureVDF

void ConfigureDOS( int bSession, str sLanguage, str sFolder );
{
  int Dlg, iYPathBox, iStartCtrlID;
  str sTitle, sHelpTopic;
  str sChoiceInherit[ max_line_length ], sValue;

  if ( bSession )
  {
    sTitle = "DataFlex session setup - " + sFolder;
    iStartCtrlID = id_Inherit_Static;
    sFolder = gsREGFLDPROJECTS + sFolder;
    sChoiceInherit = gsSELECTNONE + "()" + GetSubkeys( gsREGFLDROOT + gsREGFLDPROJECTS, TRUE );
  }
  else
  {
    sTitle = "DataFlex version setup - " + sFolder;
    iStartCtrlID = id_DFPath_Static;
    sFolder = gsREGFLDLANGUAGES + sFolder;
  }

  sHelpTopic = gsHELPPATH + "MEW_DF^";
  if ( bSession)
  {
    sHelpTopic += "Current Session (DOS)";
  }
  else
  {
    sHelpTopic += "DataFlex DOS";
  }

  DlgCreate( Dlg );

  // Inherit from
  if ( bSession )
  {
    DlgAddCtrl( Dlg, dlg_GroupBox, "", 1, 1, 67, DLG_Units + 21 , -1, 0, "" );
    DFAddCtrlChoice( Dlg, "Inherit from", id_Inherit_Static, sChoiceInherit, sFolder, gsREGINHERIT, 1, 7 + DLG_Units );
    iYPathBox = 3;
  }
  else iYPathBox = 1;

  // Paths
  DlgAddCtrl( Dlg, dlg_GroupBox, "Paths", 1, iYPathBox, 67, DLG_Units + 68 , -1, 0, "" );

  DFAddCtrlCBTB( Dlg, "DFPath"    , id_DFPath_Static    , sFolder, gsREGDFPATH    ,  1, 7 + DLG_Units );
  DFAddCtrlCBTB( Dlg, "MakePath"  , id_MakePath_Static  , sFolder, gsREGMAKEPATH  , -14, 1 );
  DFAddCtrlCBTB( Dlg, "Path"      , id_DFProg_Static    , sFolder, gsREGDFPROG    , -14, 1 );
  DFAddCtrlCBTB( Dlg, "DFEnv"     , id_DFEnv_Static     , sFolder, gsREGDFENV     , -14, 1 );
  DFAddCtrlCBTB( Dlg, "Home"      , id_Home_Static      , sFolder, gsREGHOME      , -14, 1 );

  // Other settings
  DlgAddCtrl( Dlg, dlg_GroupBox, "", 1, DLG_PosOffset + 1, 67, DLG_Units + 80 , -1, 0, "" );

  DFAddCtrlCBTB( Dlg, "DFComp"    , id_DFComp_Static    , sFolder, gsREGDFCOMP    ,   1, 7 + DLG_Units );
  DFAddCtrlCBTB( Dlg, "Explorer"  , id_Explorer_Static  , sFolder, gsREGEXPLORER  , -14, 1 );
  DFAddCtrlCBTB( Dlg, "DFIndex"   , id_DFIndex_Static   , sFolder, gsREGDFINDEX   , -14, 1 );
  DFAddCtrlCBTB( Dlg, "DFFile"    , id_DFFile_Static    , sFolder, gsREGDFFILE    , -14, 1 );
  DFAddCtrlCBTB( Dlg, "DFMaint"   , id_DFMaint_Static   , sFolder, gsREGDFMAINT   , -14, 1 );
  DFAddCtrlCBTB( Dlg, "AppBuilder", id_AppBuilder_Static, sFolder, gsREGAPPBUILDER, -14, 1 );

  // Buttons
  DFAddButtons( Dlg, TRUE );

  int Result = DlgExecute( Dlg, iStartCtrlID + 1, sTitle , sHelpTopic, "/INITMAC=CBCHANGEALL", 0 );
  Return_Int = 0;
	if ( Result ) {

    if ( bSession )
    {
      // Only sessions can set the inherit property
      sValue = DlgGetStr( dlg, id_Inherit_Text );
      if ( sValue == gsSELECTNONE) {
        sValue = "";
      }
      SetKeyFromRegistry( sFolder, gsREGINHERIT, sValue);
    }

    ProcessValue( Dlg, sFolder, gsREGDFPATH    , id_DFPath_Static    );
    ProcessValue( Dlg, sFolder, gsREGMAKEPATH  , id_MakePath_Static  );
    ProcessValue( Dlg, sFolder, gsREGDFPROG    , id_DFProg_Static    );
    ProcessValue( Dlg, sFolder, gsREGDFENV     , id_DFEnv_Static     );
    ProcessValue( Dlg, sFolder, gsREGHOME      , id_Home_Static      );

    ProcessValue( Dlg, sFolder, gsREGDFCOMP    , id_DFComp_Static    );
    ProcessValue( Dlg, sFolder, gsREGEXPLORER  , id_Explorer_Static  );
	  ProcessValue( Dlg, sFolder, gsREGDFINDEX   , id_DFIndex_Static   );
  	ProcessValue( Dlg, sFolder, gsREGDFFILE    , id_DFFile_Static    );
  	ProcessValue( Dlg, sFolder, gsREGDFMAINT   , id_DFMaint_Static   );
  	ProcessValue( Dlg, sFolder, gsREGAPPBUILDER, id_AppBuilder_Static);
    
    RefreshSettings();

	}
  DlgKill( Dlg );

}  // ConfigureDOS

void ConfigureX( int bSession, str sFolder )
{
  int bVDF;
  str sLanguage;

  // Language
  if ( bSession )
  {
    sLanguage = gsLanguage;
  }
  else
  {
    sLanguage = sFolder;
  }

  bVDF = ( GetLanguageValue( sLanguage, gsREGTYPE ) == gsTYPEWINDOWS95 );

  if ( bVDF )
  {
    ConfigureVDF( bSession, sLanguage, sFolder );
  }
  else
  {
    ConfigureDOS( bSession, sLanguage, sFolder );
  }

}  // ConfigureX

str GetLangVersion( str sTitle, int bCheckCurrentLanguage )
{
  int Dlg, iLanguage, bInstalled, iCount;
  str sLanguage, sSessionLanguage, sChoice;
  str sArrayDF[ max_line_length ];

  // ---------------------------------------------------------------------
  // Make sure the variables are available
  // 
  RefreshSettings();

  // ---------------------------------------------------------------------
  // initialize the array of languages
  // 
  sArrayDF = GetStringFromRegistry( gsREGFLDPROPERTIES, gsREGLANGUAGES );

  // -------------------------------------------------------------------
  // Determine which languages are really present and get those names
  // 
  sSessionLanguage = gsLanguage;
  sChoice          = "";
  iCount           = 0;
  iLanguage        = 0;

  while ( Length(sLanguage = Parse_Str( "/"+Str(++iCount)+"=", sArrayDF )) !=0 ) {
      
    if ( GetLanguageValue( sLanguage, gsREGTYPE ) == gsTYPEWINDOWS95 ) {
      bInstalled = Length( GetVDFRootDir( GetLanguageValue( sLanguage, gsREGROOTREGKEY ) 
                                        + GetLanguageValue( sLanguage, gsREGVDFROOTDIRKEY ))) != 0;
    }
    else bInstalled = TRUE;

    if ( bInstalled ) {
      if ( sSessionLanguage == sLanguage ) {
        iLanguage = iCount;
      }
      sChoice += GetLanguageValue( sLanguage, gsREGNAME ) + "()";
    }
  }

  // -------------------------------------------------------------------
  // Handle unknown language
  // 
  if ( iLanguage == 0)
  {
    iLanguage = 1;
    if ( (bCheckCurrentLanguage) && (Length( sSessionLanguage ) != 0 )) {
      MessageBox(0, "The DataFlex version which was set for this session (" + sSessionLanguage +
                    ") is unknown or that product isn\'t installed.", 'Warning',
                    mb_ok | mb_iconexclamation );
    }
  }

  // -------------------------------------------------------------------
  // Use a dialog to ask the user the (new) version.
  // 
  DlgCreate( Dlg );
    
  DlgAddCtrl( Dlg, dlg_static, "Language",
      dlg_PosOffset + 0, dlg_PosOffset + 0,
      0, 0,
      id_Language_Static, 0, "" );

  DlgAddCtrl( dlg, dlg_choice, sChoice,
      dlg_PosOffset + 14, dlg_PosOffset + 0,
      25, 0,
      id_Language_Choice, 0, "" );

  DlgSetInt( dlg, id_Language_Choice, iLanguage );

  // Buttons
  DFAddButtons( Dlg, TRUE );

  int Result = DlgExecute( Dlg, id_Language_Choice, sTitle,
                            gsHELPPATH + "MEW_DF^Set version", "", 0 );
  Return_Int = 0;
    
  // -------------------------------------------------------------------
  // If the user pressed the OK-button, set the new language in the
  // project.
  // 
  if ( Result ) {

    iLanguage = DlgGetInt( Dlg, id_Language_Choice );
    sSessionLanguage = Parse_Str( "/"+Str( iLanguage )+"=", sArrayDF );
  }
  else {
    sSessionLanguage = "";
  }
  DlgKill( Dlg );

  return ( sSessionLanguage );
}  // GetLangVersion  
void ConfigureSession( str sSession = Parse_Str( "/S=", MParm_Str ));
{
  ConfigureX( TRUE, sSession );
}  // ConfigureSession

void ConfigureCurrentSession
{
  ConfigureSession( gsProject );
}  // ConfigureCurrentSession

void ConfigureLanguage()
{
  str sLanguage[ 100 ];
  sLanguage = GetLangVersion( "Select the version", FALSE );

  if ( Length( sLanguage ) != 0 ) {
    ConfigureX( FALSE, sLanguage );
  }
}  // ConfigureLanguage

void SetVersionSession( str sFolder )
{
  int iError;
  str sLanguage, sSessionLanguage;

  // ---------------------------------------------------------------------
  // Check the sessionname for illegal characters
  // 
  iError = XPos( "\\", sFolder, 1 );
  if ( !iError) {
    CreateSubkey( gsREGFLDPROJECTS + sFolder );
    iError = iRegError != giREGSUCCESS;
  }
  if ( iError) {
    MessageBox(0, "This sessionname ("  + sFolder + ") cannot be used with this add-on.",
                  'Warning', mb_ok | mb_iconexclamation );
  }
  else {
    sSessionLanguage = GetLangVersion( "Set version " + sFolder, FALSE );
    
    // -------------------------------------------------------------------
    // If the user pressed the OK-button, set the new language in the
    // project.
    // 
    if ( Length( sSessionLanguage) != 0 ) {

      // Set settings in registry
      SetKeyFromRegistry( gsREGFLDPROJECTS + sFolder, gsREGLANGUAGE, sSessionLanguage );
      
      RefreshSettings();
    }
  }

}  // SetVersionSession

void SetVersionCurrentSession()
{
  RefreshSettings();

  SetVersionSession( gsProject );
}  // SetVersionCurrentSession  

/******************************************************************************
															 Multi-Edit Macro
                               01-Dec-96  14:10

  Function: Set DataFlex specific properties.  Should only be run by the
						LangSetProperties macro.

	Entry   : str GStr			- Name of global string containing properties (/GSTR=)
						str ParmStr		- Misc parameters
							/L=str				- Language name to show on title bar

	Exit    : None

               Copyright (C) 1996 by GJ. Wijnands
******************************************************************************/
void dfSetProperties(
			str GStr 		= Parse_Str( "/GSTR=", MParm_Str ),
			str ParmStr = MParm_Str
)
{
  int Dlg, iOptions;

  // Make sure the variables are available
  RefreshSettings();

  DlgCreate( Dlg );

	DlgAddCtrl( Dlg, dlg_GroupBox, "Options",
      1, 1,
      40, 3,
			-1, 0, "" );

	DlgAddCtrl( Dlg, dlg_CheckBox, "&Paren Closure Highlight",
			dlg_PosOffset + 1, dlg_PosOffset + 1,
			0, 0,
			id_ParenHiCB, 0, "" );
  DlgSetInt( Dlg, id_ParenHiCB, gbClosureHighlight );

  DlgAddCtrl( Dlg, dlg_CheckBox, "&Keyword construct matching",
      dlg_PosOffset + 0, dlg_PosOffset + 1,
      0, 0,
      id_KeywordHiCB, 0, "" );
  DlgSetInt( Dlg, id_KeywordHiCB, gbConstructMatching );

  DFAddButtons( Dlg, TRUE )

  int Result = DlgExecute( Dlg, id_ParenHiCB, "DataFlex Properties Setup",
      gsHELPPATH + "MEW_DF^DATAFLEX PROPERTIES", "", 0 );
  Return_Int = 0;
	if ( Result ) {
    // Set properties in registry
    SetKeyFromRegistry( gsREGFLDPROPERTIES, gsREGCLOSUREHIGHLIGHT , Str(( DlgGetInt( Dlg, id_ParenHiCB   ) != 0 )));
    SetKeyFromRegistry( gsREGFLDPROPERTIES, gsREGCONSTRUCTMATCHING, Str(( DlgGetInt( Dlg, id_KeywordHiCB ) != 0 )));
    // Update the variables.
    RefreshSettings();
	}
	DlgKill( Dlg );

}  // dfSetProperties


str AskDFComp(  )
/********************************************************************
                                                       Multi-Edit Macro
                                                         1-2-98 19:34

  Function: This function will ask the user for DFComp.
  Entry   : -
  Exit    : DFComp

                                              Copyright 1998 By Gerard J Wijnands
***********************************************************************/
{
  int iDlg, iOptions;
  str sRetval;

  DlgCreate( iDlg );

  DlgAddCtrl( iDlg, Dlg_STATIC, "DFComp",
      0, dlg_PosOffset,
      0, 0,
      id_DFComp_Static, 0, "" );

  DlgAddCtrl( iDlg, Dlg_TEXT, "",
      dlg_PosOffset + 14, dlg_PosOffset,
      50, 0,
      id_DFComp_Text, 0, "/ML=" + str(max_line_length) );

  DFAddButtons( iDlg, FALSE );

  int Result = DlgExecute( iDlg, id_DFComp_Text, "Compiler options",
      gsHELPPATH + "MEW_DF^DATAFLEX PROPERTIES", "", 0 );
  Return_Int = 0;
	if ( Result ) {
    sRetVal = DlgGetStr( iDlg, id_DFComp_Text );
	}
  else {
    sRetval = "";
  }
  DlgKill( iDlg );

  return ( sRetVal );

}  // AskDFComp


str AskCommandLine( str sCommandLine )
/********************************************************************
                                                       Multi-Edit Macro
                                                         3-2-98 21:14

  Function: This function will ask the user to edit the command line
  Entry   : Default commandline
  Exit    : The commandline the user wants

                                    Copyright 1998 By Gerard J Wijnands
***********************************************************************/
{
  int iDlg, iOptions;
  str sRetval;

  DlgCreate( iDlg );

  DlgAddCtrl( iDlg, Dlg_STATIC, "Run",
      0, dlg_PosOffset,
      0, 0,
      id_DFComp_Static, 0, "" );

  DlgAddCtrl( iDlg, Dlg_TEXT, sCommandLine,
      dlg_PosOffset + 14, dlg_PosOffset,
      50, 0,
      id_DFComp_Text, 0, "/ML=" + str(max_line_length) );

  DFAddButtons( iDlg, TRUE );

  int Result = DlgExecute( iDlg, id_DFComp_Text, "Run program",
      "", "", 0 );
  Return_Int = 0;
	if ( Result ) {
    sRetVal = DlgGetStr( iDlg, id_DFComp_Text );
	}
  else {
    sRetval = "";
  }
  DlgKill( iDlg );

  return ( sRetVal );

}  // AskCommandLine