/******************************************************************************
 $Header:: /MewAddOn/Multi Edit/dataflex.sh 4     1-02-98 21:18 Gerard        $

 Copyright (c) 1997 G.J. Wijnands. All rights reserved.

														MULTI-EDIT MACRO FILE

 Name:   `name`

 Description:  `description`

******************************************************************************/


/*

 Text                         registry (Properties)   MEW global                Value     i.e.
 ===========================================================================================================
 Matching
 --------
 Paren Closure Highlight      ClosureHighlight        !DFSETCLOSUREHIGHLIGHT       boolean
 Keyword construct matching   ConstructMatching       !DFSETCONSTRUCTMATCHING      boolean
 
 Indenting
 ---------
 Auto unindent                AutoUnindent            !DFSETAUTOUNINDENT           boolean
 Indent keywords              IndentKeywords          !DFSETINDENTKEYWORDS         string    Procedure
 Unindent keywords            UnindentKeywords        !DFSETUNINDENTKEYWORDS       string    End_Procedure
 Special keywords (indent)    SpecialIndentKeywords   !DFSETSPECIALINDENTKEYWORDS  string    If
 
 EOL comment
 -----------
 Auto insert EOL comment      AutoEOLComment          !DFSETAUTOEOLCOMMENT         boolean
 EOL comment header           EOLCommentHeader        !DFSETEOLCOMMENTHEADER       boolean
 EOL header width             EOLHeaderWidth          !DFSETEOLHEADERWIDTH         byte
 Auto fill EOL comment        EOLAutoFillComment      !DFSETEOLAUTOFILLCOMMENT     boolean
 Auto fill keywords           EOLAutoFillKeywords     !DFSETEOLAUTOFILLKEYWORDS    string    End_Procedure
 Auto fill tags               EOLAutoFillTags         !DFSETEOLAUTOFILLTAGS        string    Procedure
 EOL adjust comment           EOLAdjustComment        !DFSETEOLADJUSTCOMMENT       boolean
 EOL adjust comment column    EOLAdjustColumn         !DFSETEOLADJUSTCOLUMN        integer
      
 Tags
 ----
 Tag keywords                 TagKeywords             !DFSETTAGKEYWORDS            string    Procedure

 Project
 -------
 <Projectname>                <Project>               !DFSETPROJECT                string    TOGVNG
 DataFlex version             Language                !DFSETLANGUAGE               string    DF23
 Inherit from                 Inherit                 !DFSETINHERIT                string
 
 DFPath                       DFPath                  !DFSETDFPATH                 string
 MakePath                     MakePath                !DFSETMAKEPATH               string
 DFProg                       DFProg                  !DFSETDFPROG                 string
 DFEnv                        DFEnv                   !DFSETDFENV                  string
 Home                         Home                    !DFSETHOME                   string
 Searchpath                   SearchPath              !DFSETSEARCHPATH             string
 
 Workspace                    Workspace               !DFSETWORKSPACE              string

 DFComp                       DFComp                  !DFSETDFCOMP                 string
 DFPreComp                    DFPreComp               !DFSETDFPRECOMP              string    p
 Explorer                     Explorer                !DFSETEXPLORER               string
 DFIndex                      DFIndex                 !DFSETDFINDEX                string
 DFFile                       DFFile                  !DFSETDFFILE                 string
 DFMaint                      DFMaint                 !DFSETDFMAINT                string
 AppBuilder                   AppBuilder              !DFSETAPPBUILDER             string

 DFSpy                        DFSpy                   !DFSETDFSPY                  string
 Compiler                     Compiler                !DFSETCOMPILER               string
 Runtime                      Runtime                 !DFSETRUNTIME                string
 Runtime parameters           RuntimeParams           !DFSETRUNTIMEPARAMS          string
 Online helpfile              OnlineHelpfile          !DFSETONLINEHELPFILE         string

 Searchstring                 Searchstring            !DFSETSEARCHSTRING           string

*/
#define gsLANGUAGELONG     "DATAFLEX"
#define gsLANGUAGESHORT    "DF"

#define gsDFEndOfWord      " \t\xFF"
#define gsDFWordDelimits   "()""',@!%^&*{}[]?/||;:" + gsDFEndOfWord
#define gsDFTAGStartOfLine "^<b0>((\\#\\$)|(\\[<b0>\\])|(<b1>))*<b0>"
#define gsDFTAGEnd         "<b1>"
#define gsDFEOLComment     "//"
#define gsTRUE             "1"
#define gsHELPPATH        me_path + "DATAFLEX\\"

#define gsTYPEDOS       "DOS"
#define gsTYPEWINDOWS95 "W95"

#define gsASKDFCOMP "!ASKDFCOMP"
#define gsDUMDFDEBUG   "!DFD"
#define gsDUMDFPRECOMP "!DFP"
#define gsDFERREXT     "!DFERREXT"

global 
		{
      int gbClosureHighlight        "!DFSETCLOSUREHIGHLIGHT";
      int gbConstructMatching       "!DFSETCONSTRUCTMATCHING";
      int gbDebug                   "!DFSETDEBUG";

      int gbAutoUnindent            "!DFSETAUTOUNINDENT";
      str gsIndentKeywords          "!DFSETINDENTKEYWORDS";
      str gsUnindentKeywords        "!DFSETUNINDENTKEYWORDS";
      str gsSpecialIndentKeywords   "!DFSETSPECIALINDENTKEYWORDS";

      int gbAutoEOLComment          "!DFSETAUTOEOLCOMMENT";
      int gbEOLCommentHeader        "!DFSETEOLCOMMENTHEADER";
      int giEOLHeaderWidth          "!DFSETEOLHEADERWIDTH";
      int gbEOLAutoFillComment      "!DFSETEOLAUTOFILLCOMMENT";
      str gsEOLAutoFillKeywords     "!DFSETEOLAUTOFILLKEYWORDS";
      str gsEOLAutoFillTags         "!DFSETEOLAUTOFILLTAGS";
      int gbEOLAdjustComment        "!DFSETEOLADJUSTCOMMENT";
      int giEOLAdjustColumn         "!DFSETEOLADJUSTCOLUMN";

      str gsTagKeywords             "!DFSETTAGKEYWORDS";

      str gsProject                 "!DFSETPROJECT";
      str gsLanguage                "!DFSETLANGUAGE";
      str gsInherit                 "!DFSETINHERIT";

      str gsDFPath                  "!DFSETDFPATH";
      str gsMakePath                "!DFSETMAKEPATH";
      str gsDFProg                  "!DFSETDFPROG";
      str gsDFEnv                   "!DFSETDFENV";
      str gsHome                    "!DFSETHOME";
      str gsSearchPath              "!DFSETSEARCHPATH";
      str gsDDSearchPath            "!DFSETDDSEARCHPATH";
      str gsProgramPath             "!DFSETPROGRAMPATH";

      str gsWorkspace               "!DFSETWORKSPACE";
      str gsMainApp                 "!DFSETMAINAPP";
      str gsMainAppSkip             "!DFSETMAINAPPSKIP";
          
      str gsDFComp                  "!DFSETDFCOMP";
      str gsDFPreComp               "!DFSETDFPRECOMP";
      str gsBugDFComp               "!DFSETBUGDFCOMP";
      str gsExplorer                "!DFSETEXPLORER";
      str gsDFIndex                 "!DFSETDFINDEX";
      str gsDFFile                  "!DFSETDFFILE";
      str gsDFMaint                 "!DFSETDFMAINT";
      str gsAppBuilder              "!DFSETAPPBUILDER";

      str gsDFSpy                   "!DFSETDFSPY";
      str gsBugCompiler             "!DFSETBUGCOMPILER";
      str gsCompiler                "!DFSETCOMPILER";
      str gsRuntime                 "!DFSETRUNTIME";
      str gsRuntimeParams           "!DFSETRUNTIMEPARAMS";
      str gsOnlineHelpfile          "!DFSETONLINEHELPFILE";

      str gsVDFRootdir              "!DFSETVDFROOTDIR";
      str gsWorkSpacesKey           "!DFSETWORKSPACESKEY";
      str gsMainAppKey              "!DFSETMAINAPPKEY";

      str gsSearchstring            "!DFSETSEARCHSTRING";
      str gsType                    "!DFSETTYPE";
      int gbDFEnv                   "!DFSETBDFENV";

      // -----------------------------------------------------------------
      // Commandline - compiling
      str gsCmdLineCompiler         "!DFCOMPILER";
      str gsCmdLineCompile          "!DFCOMPILE";
      str gsCmdLineDFComp           "!DFCOMP";
    };

prototype DataFlex {
  str  ConvertToRegExp( str sSearch );
  void RefreshSettings();
  str GetVDFRootDir( str sVDFRootdirKey );
}