/******************************************************************************
 Copyright (c) 1997 G.J. Wijnands. All rights reserved.

														MULTI-EDIT MACRO FILE

 Name:   DataFlex

 Description:  This macro file contains macro's which act as an intermediair
               between MEW and DataFlex.

 EXTERNAL functions:

 INTERNAL functions:

 $Header:: /MewAddOn/Multi Edit/dfinter.s 10    1-02-98 21:04 Gerard          $

******************************************************************************/
macro_file DFInter;

// MEW
#include WINEXEC.SH
#include DBTOOLS.SH
#include METOOLS.SH
#include MEW.SH
#include DFREG.SH
#include win32.sh
#include debug.sh

// Add-on
#include DATAFLEX.SH
#include DFCONFIG.SH

#define _CTGlobal					"CT_"

#define gsGLOBALCOMPTYPE     _CTGlobal + gsLANGUAGELONG
#define gsLASTCOMPILEDWINDOW "Last_Compiled_Window"
#define gsDFARRAYWINDOW       "!DFArrayWindow"

#define _db_pgm_Page      "PGM.DB"

// PGM record field name constants
#define _db_pgm_Program		"PGM"
#define _db_pgm_ErrFile		"EFILE"
#define _db_pgm_PreMac		"BCMAC"
#define _db_pgm_PostMac		"ACMAC"
#define _db_pgm_ErrMac		"EMAC"
#define _db_pgm_ErrFndRE	"SRE"
#define _db_pgm_ErrRepRE	"RRE"
#define _db_pgm_ErrXtra		"XTR"

global
		{
      str gsCOMPILEROPTION "!PGM";
    };

/******************************************************************************
															 Multi-Edit Macro
                               08-Dec-96  22:03

  Function: Return a unique batch file based upon FName.

  Entry   : str FName - The name of the batch file

  Exit    : str       - Batch file name with full path

               Copyright (C) 1996 by G.J. Wijnands
******************************************************************************/
str GetBatchFileName( str FName = Parse_Str( "/F=", MParm_Str ) ) Trans2 {
  int Count=0,Chars;
	str CntStr;
  str Name;
  str sTempPath = Temp_Path;

  if ( Copy( sTempPath, svl(sTempPath), 1 ) != "\\" )
  {
    sTemppath += "\\";
  }

  // Delete the extension and the path.
  Name = Truncate_Path( Truncate_Extension( FName ));

  // Check for room of at least 3 digits at the end of the filename
  if ( ( Svl( Name ) ) > 5 ) {
    Name = Copy( Name, 1, 5 );
	}

  Chars = 8 - svl( Name );              // Number of digits

  // The following routine does no checking for exceeding the limit,
  // because it's very unlikely to happen.
  do {
    CntStr = "0000000" + Hex_Str( Count++ );
    CntStr = Copy( CntStr, Svl( CntStr ) - (Chars - 1), Chars );
    FName = sTempPath + Name + CntStr + ".BAT";
	} while ( File_Exists( FName ) != 0 );
  Error_Level = 0;

  return ( FName );

}  // GetBatchFileName

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: Gets the setting for DFPath.

  Entry   : int bCompiler - Specifies whether the DFPath for the compiler or the
                            runtime must be searched for.

  Exit    : str           - The path which must be used.

               Copyright (C) 1996 by G.J. Wijnands
******************************************************************************/
str GetDFPath( int bCompiler )
{
  str sDFPath[ max_line_length ];

  if ( bCompiler ) sDFPath = gsMakePath;
  else sDFPath = gsDFPath;

  return ( sDFPath );
}  // GetDFPath

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: Takes care of the removal of the batchfile after execution of the
            command.

  Entry   : str sFName - the name of the batchfile.

  Exit    : None

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void Einde( str sFName[ 128 ] = Parse_Str( "/B=", MParm_Str ) )
{
  Del_File( sFName );
}  // Einde

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: Writes one line to a window which sets (batchfile-language) an
            environment variable.

  Entry   : str sEnvVar - the name of the environment variable.
            str sValue  - the value the environment variable must get.

  Exit    : None

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void SetEnvVar( str sEnvvar, str sValue )
{
  if ( svl(sValue) != 0 )
  {
    Put_Line("Set " + sEnvvar + "=" + sValue );
    Down;
  }
  else
  {
    Put_Line("Rem Set " + sEnvvar + "= <none>"  );
    Down;
  }
}

str TranslateMetaCommands( str Cmdline[ MAX_LINE_LENGTH ] ) trans2
/*******************************************************************************
Description:  Translates cmdline so that any occurances of all MEW add-on
              metacommands are expanded out. After that the MEW metacommands are
 							expanded out.

							(C) Copyright 1997 by G.J. Wijnands
*******************************************************************************/
{
	if ( XPos( "<", CmdLine, 1 ) ) {

		int iCurPos;
		int Jy;
		int iCurPos2;
		int UseLFN = False;

		str Alias;
    str sValue[ MAX_LINE_LENGTH ];

    iCurPos = 1;
    while ( iCurPos = XPos( "<", Cmdline, iCurPos ) ) {
      if ( ( Jy = XPos( ">", Cmdline, iCurPos ) ) == 0 ) {
        break;
      }
			if ( iCurPos2 = XPos( "<", Cmdline, iCurPos + 1 ) ) {
				// Check for input redirection
				if ( iCurPos2 < Jy ) {
					++iCurPos;
					continue;
				}
			}
      Jy = Jy - iCurPos - 1;
			Alias = Copy( Cmdline, iCurPos + 1, 1 );
      if ( XPos( Alias, "%~", 1 ) ) {
        sValue = Copy( CmdLine, iCurPos + 2, Jy - 1 );
      }
			else {
      	Alias = Copy( CmdLine, iCurPos + 1, Jy );
			}
      switch ( Caps( Alias ) ) {
        case "EXPLORER"   : sValue = gsExplorer;                 break;
        case "DFFILE"     : sValue = gsDFFile;                   break;
        case "DFINDEX"    : sValue = gsDFIndex;                  break;
        case "DFMAINT"    : sValue = gsDFMaint;                  break;
        case "DFSPY"      : sValue = gsDFSpy;                    break;
        case "APPBUILDER" : sValue = gsAppBuilder;               break;
        case "WORKSPACE"  : sValue = gsWorkspace;                break;
        case "RUN"        : if ( Length( gsProgramPath ) != 0 )
                                 sValue = "<RUNPROG> " + gsProgramPath + "<NAME>";
                            else sValue = "<RUNPROG> <NAME>";
                            break;
        case "RUNPROG"    : sValue = gsRuntime + " <RUNPARAMS>"; break;
        case "RUNPARAMS"  : sValue = gsRuntimeParams;            break;

				default:
          iCurPos += Jy + 2;
          Jy = 0;
      }
      if ( Jy ) {
        Cmdline = Str_Del( Cmdline, iCurPos, Jy + 2 );
        if ( Svl( sValue ) ) {
          Cmdline = Str_Ins( sValue, Cmdline, iCurPos );
        }
      }
    }
		CmdLine = TranslateCmdline( CmdLine, File_Name );
	}
  return ( Cmdline );

}  // TranslateMetaCommands

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: Handles the special commands.

  Entry   : str sCommand - The specified command.
            str sParam   - the parameters

  Exit    : sCommand & sParam - modified

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void TransformCommand( str &sCommand[ MAX_LINE_LENGTH ], str &sParam[ MAX_LINE_LENGTH ] )
{
  int iPos;

	if ( svl(sParam) !=0 )
	{
		sCommand += " " + sParam;
	}
	sCommand = TranslateMetaCommands( sCommand );

  iPos = XPos( " ", sCommand, 1 );
  if ( iPos )
  {
    sParam = Copy( sCommand, iPos + 1, svl( sCommand ) - iPos );
    sCommand = Copy( sCommand, 1, iPos - 1 );
  }
  else
  {
    sParam = "";
  }
}  // TransformCommand

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: To write a batchfile which can start the specified command.

  Entry   : str sCommand       - the command which must be started
            str sParam         - the parameters for the command
            str sBugCommand    - the command which must be started for debugging
            str sBugParam      - the parameters for the debugging command
            int bWaitOnExecute - <none>
            str sBatchfilename - the name of the batchfile.

  Exit    : int bWaitOnExecute - indicates whether there must be wait for the
                                 execution to end or not.

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void WriteBatchFile( str sCommand   , str sParam,
                     str sBugCommand, str sBugParam,
                     int &bWaitOnExecute, str sBatchfilename )
{
  int bCompile, iCurWin = Cur_Window, bDFEnv;
  str sFilename[200];

  bCompile  = Caps( Remove_Space( Truncate_Path( Truncate_Extension( sCommand )))) == 'DFCOMP';
  sFilename = File_Name;

  Create_Window;
  Window_Attr = 0x81;
  File_Name = sBatchfilename;

  Put_Line("@Echo Off");
  Down;

  // ---------------------------------------------------------------------
  // Determine whether DFEnv should be used or just DFPath..
  //
  bDFEnv = gbDFEnv And ( Length( gsDFEnv )!=0 );

  if ( !bDFEnv )
  {
    SetEnvVar( "DFPath", GetDFPath( bCompile )   );
    SetEnvVar( "Home"  , gsHome               );
    SetEnvVar( "Path"  , gsDFProg + ";%Path%" );
  }
  else
  {
    SetEnvVar( "DFEnv" , gsDFEnv );
    SetEnvVar( "Path"  , gsDFProg + ";%Path%" );
  }
  Put_Line( sCommand + ' ' + sParam );
  Down;
  if ( Length( sBugCommand ) != 0 ) {
    Put_Line( 'If (%1)==(BUG) ' + sBugCommand + ' ' + sBugParam );
    Down;
  }
  if (gbDebug)
  {
    Put_Line( 'Pause' );
    Down;
  }

  Save_File;
  Delete_Window;
  Switch_Window( iCurWin );

  bWaitOnExecute = bCompile;

}  // WriteBatchFile

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: To start the correct DOS-runtime (or other executable) of DataFlex.

  Entry   : str sCommand - the name of the executable or a macro.
            str sParam   - the parameters

  Exit    : None

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void RunDOS( str sCommand = Parse_Str( "/C=", MParm_Str ),
             str sParam   = Parse_Str( "/P=", MParm_Str )  )
{
  int iFlags, bCompile;
  str sBatchfilename[200], sBkgTaskMac[200];

  sCommand = "<SFN>" + sCommand;
  TransformCommand( sCommand, sParam );

  sBatchfilename = GetBatchFileName("DF");
  sBkgTaskMac = "dfinter^Einde /B=" + sBatchfilename;
  WriteBatchFile( sCommand, sParam, "", "", bCompile, sBatchfilename );

  if ( Error_Level != 0 )
    {
      RM('MEERROR');
    }
  else
    {
      iFlags = _EP_FLAGS_NoSavFile | _EP_Flags_Comspec | _EP_Flags_RunBkg | _ep_Flags_SkipExec;
      if ( !bCompile )
      {
        iFlags |= _EP_FLAGS_AutoRun;
      }
      BkgTaskMac = sBkgTaskMac;
      ExecProg( sBatchfilename, "", "", "", iFlags )

    }
}  // RunDOS

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: To start the correct W95-runtime (or other executable) of DataFlex.

  Entry   : str sCommand - the name of the executable or a macro.
            str sParam   - the parameters

  Exit    : None

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void RunVDF( str sCommand = Parse_Str( "/C=", MParm_Str ),
             str sParam   = Parse_Str( "/P=", MParm_Str )  )
{
  int iFlags;
  str sCommandLine[ max_line_length ];

  sCommand = "<LFN>" + sCommand;
	TransformCommand( sCommand, sParam );

  sCommandline = gsVDFRootDir + "\\" + sCommand + " " + sParam;

//  sCommandline = AskCommandLine( sCommandline );

  if ( svl( sCommandLine )) {
    iFlags = _EP_FLAGS_NoSavFile | _EP_Flags_RunBkg | _ep_Flags_SkipExec | _EP_FLAGS_AutoRun;
    BkgTaskMac = "";
    ExecProg( sCommandline, "", "", "", iFlags )
  }

}  // RunVDF

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: To start the correct runtime (or other executable) of DataFlex.

  Entry   : str sCommand - the name of the executable or a macro and the parameters.

  Exit    : None

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void Run( str sCommand = MParm_Str )
{
  str sMACRun;

  sMACRun = GetLanguageValue( gsLanguage, "MACRun" );

  RM( sMACRun + " " + sCommand );
}  // Run

void AddFilenameToArray( str sBatchfilename )
{
  int iActiveWindow = Window_ID;
  str sFilename;

  sFilename = File_Name;
  if ( Global_Int( gsDFArrayWindow ) == 0)
  {
    Create_Window;
    Window_Attr = 0x81;
    Set_Global_Int( gsDFArrayWindow, Window_ID );
  }
  else
  {
    Switch_Window( Global_Int( gsDFArrayWindow ) );
  }

  Eof;
  if ( C_Col != 1)
  {
    Down;
  }
  Put_Line( sFilename + "=" + sBatchfilename);
  Down;
  Switch_Window( iActiveWindow );

}  // AddFilenameToArray

str GetBatchfilenameFromArray( str sFilename )
{
  int iActiveWindow = Window_ID, iPos;
  str sBatchfilename;

  if ( Global_Int( gsDFArrayWindow ) != 0)
  {
    sFilename = Caps( sFilename );
    Switch_Window( Global_Int( gsDFArrayWindow ) );
    Tof;
    if (Find_Text( sFilename + "=?+", 0, _OldExp ))
    {
      sBatchfilename = Found_Str;
      iPos = XPos( "=", sBatchfilename, 1);
      sBatchfilename = Copy( sBatchfilename, iPos + 1, svl( sBatchfilename ) - iPos );
      Del_Line;
    }

    Switch_Window( iActiveWindow );
  }

  return ( sBatchFilename );

}  // GetBatchfilenameFromArray

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: To prepare everything for compilation of a DataFlex program i.e.
            the searchstring and the extensions are setup.

  Entry   : None

  Exit    : None

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void SetProgramType( str sDFComp )
{
//  str sGlobalCompType[Max_Line_Length];
//  str CompRec[ max_Line_Length ];
//  str sErrFile;
  str sExtension;
//  int Jx, Flags;

  // Set the correct find string for the error processing...
//  sGlobalCompType = gsLANGUAGELONG;
//  Jx         = 0;
//  Flags      = _sf_ErrorNoRec | _sf_FirstField | _dbf_NoDelWin;
//  Return_Int = DbGetRecord( _ConfigFile, _db_pgm_Page, _db_pgm_Program, sGlobalCompType, Jx, Flags, "" );
//  if ( Return_Int == _noError ) {

    sExtension = "PRN";
    if ( XPOS( "w", sDFComp, 1 )) sExtension = "ERR";
    if ( XPOS( "p", sDFComp, 1 )) sExtension = "PRP";

    Set_Global_Str( gsDFERREXT, sExtension );

//    sErrFile = "<LFN><FILE>." + sExtension;

//    DbUpdateFields(sGlobalCompType , _db_Delimit + _db_pgm_ErrFndRE + "="+ gsSearchString , _db_Delimit + _db_pgm_ErrFndRE );
//    DbUpdateFields(sGlobalCompType , _db_Delimit + _db_pgm_ErrFile  + "="+ sErrFile       , _db_Delimit + _db_pgm_ErrFile  );

    // -------------------------------------------------------------------
    // Save in the global variable
//    Set_Global_Str( gsGLOBALCOMPTYPE, sGlobalCompType );

    // -------------------------------------------------------------------
    // Save also in the DB file
//    CompRec    = gsLANGUAGELONG;
//    Flags      = _sf_FirstField | _dbf_NoDelWin | _dbf_ReplaceRec | _dbf_SaveFile;
//    Return_Int = DbPutRecord( _ConfigFile, _db_pgm_Page, _db_pgm_Program, CompRec,
//                Jx, Flags, "", sGlobalCompType );
//  }
}  // SetProgramType

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: To prepare everything for compilation of a Visual DataFlex program.

  Entry   : None

  Exit    : None

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void PreCompileVDF( int bAskDFComp, int bDFDebug, int bDFPrecomp )
{
  str sCommandline[200];
  str sDFComp, sFileName;

  sCommandline = gsVDFRootDir + "\\" + gsCompiler;

	// W95: only specify the filename without path and extension. This equals the registry
	//      entry.
	sFileName = Truncate_Path( Truncate_Extension ( GetLongName( File_Name ) ) );

  gsCmdLineCompiler = sCommandline;
  gsCmdLineCompile  = sCommandline + " " + sFilename;
  gsCmdLineDFComp   = gsDFComp;
  if (bDFPreComp) gsCmdLineDFComp += gsDFPreComp;

  //if (bDFDebug) Do nothing, 'cause there's no need to
  if (bAskDFComp) gsCmdLineDFComp = AskDFComp();

  SetProgramType( gsCmdLineDFComp ) ;

}  // PreCompileVDF

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: To prepare everything for compilation of a DataFlex (DOS) program.

  Entry   : None

  Exit    : None

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void PreCompileDOS( int bAskDFComp, int bDFDebug, int bDFPrecomp )
{
  int bCompile;
  str sBatchfilename[200];
  str sFileName, sExtension;

  sBatchfilename = GetBatchFileName("DF");
  WriteBatchFile( gsCompiler   , "%2.%3 %4 %5 %6 %7 %8 %9",
                  gsBugCompiler, "%2",
                  bCompile, sBatchfilename );

	// DOS: Specify only the filename with extension.
	sFileName = Truncate_Path( GetShortName( File_Name ) );
  sExtension = Get_Extension( sFilename );
  sFilename  = Truncate_Extension( sFilename );

  if (bDFDebug) {
    gsCmdLineCompiler = sBatchfilename + " BUG";
    gsCmdLineDFComp   = gsBugDFComp;
  }
  else {
    gsCmdLineCompiler = sBatchfilename + " NOB";
    gsCmdLineDFComp   = gsDFComp;
  }
  gsCmdLineCompile = gsCmdLineCompiler  + " " + sFilename + " " + sExtension;

  if (bDFPreComp) gsCmdLineDFComp += gsDFPreComp;
  if (bAskDFComp) gsCmdLineDFComp = AskDFComp();

  SetProgramType( gsCmdLineDFComp ) ;

  AddFilenameToArray( sBatchfilename );

}  // PreCompileDOS

/******************************************************************************
															 Multi-Edit Macro
                               30-Apr-97  22:03

  Function: To prepare everything for compilation of a DataFlex (DOS) program.

  Entry   : None

  Exit    : None

               Copyright (C) 1997 by G.J. Wijnands
******************************************************************************/
void PreCompile()
{

  int bAskDFComp = False;
  int bDFDebug   = False;
  int bDFPrecomp = False;

  if ( Length( gsCOMPILEROPTION ) != 0) {
    bAskDFComp = ( XPos( "<~" + gsASKDFCOMP    + ">", gsCOMPILEROPTION, 1 ) != 0 );
    bDFDebug   = ( XPos( "<~" + gsDUMDFDEBUG   + ">", gsCOMPILEROPTION, 1 ) != 0 );
    bDFPrecomp = ( XPos( "<~" + gsDUMDFPRECOMP + ">", gsCOMPILEROPTION, 1 ) != 0 );
  }

  if ( gsType == gsTYPEWINDOWS95 )
	{
    PreCompileVDF( bAskDFComp, bDFDebug, bDFPrecomp );
	}
	else
	{
    PreCompileDOS( bAskDFComp, bDFDebug, bDFPrecomp );
	}

}  // PreCompile

/******************************************************************************
															 Multi-Edit Macro
															 13-Jun-95  16:14

  Function: Do post compile processing for DataFlex compiler.

  Exit    : Return_Int
							True			- No Errors found
							False			- Continue error processing

						Return_Str	- Message to display when Return_Int is True

							 Copyright (C) 1995 by American Cybernectic, Inc.
********************************************************************( ldh )***/
void PostCompile( ) Trans2 {
//  str sCompRec[ Max_Line_Length ] = Global_Str( gsGLOBALCOMPTYPE );
//  str sErrFile = Parse_Str( _db_Delimit + _db_pgm_ErrFile  + "=", sCompRec );
//  str sExtension = Get_Extension( sErrFile );
  str sExtension = Global_Str( gsDFERREXT );

//====================================================================================
  if ( gsType != gsTYPEWINDOWS95 )
	{
  	str sBatchfilename;

  	sBatchfilename = GetBatchfilenameFromArray( Global_Str( gsLastCompiledWindow ) );

  	if ( svl(sBatchfilename)!=0 )
  	{
    	Einde( sBatchfilename );
  	}
	}

//====================================================================================

  Eof;
  if ( sExtension == "ERR" )
  {
    // If file not found then no errors
//    if ( Caps( Truncate_Path( File_Name ) ) != "MEERR.TMP" )
    if ( Cur_File_Size == 0 )
    {
      Return_Int = True;
      Return_Str = "No errors.";
    }
  }
  else if ( sExtension == "PRN" )
  {
    if ( Find_Text( "Errors *: 0", 0, _RegExp | _Backward ) ) {
      Return_Int = True;
      Return_Str = "No errors.";
    }
  }
  Tof;

}  // PostCompile
