/******************************************************************************
 $Header:: /MewAddOn/Multi Edit/dftag.s 1     13-01-98 19:47 Gerard           $

 Copyright (c) 1997 G.J. Wijnands. All rights reserved.

														MULTI-EDIT MACRO FILE

 Name:   `name`

 Description:  `description`

******************************************************************************/
macro_file DFTAG;

// MEW
#include METAGS.SH
#include RegExp.sh

// Add-on
#include DataFlex.sh

/****************************Multi-Edit Macro********************************

 NAME:         DFFindTag

 DESCRIPTION:  

 Deze macro bouwt de tag-lijst op voor DataFlex. Dit gebeurt a.d.h.v. een string.
 Tags binnen strings en binnen commentaar worden overgeslagen.
 
 Indien de string "Property" bevat wordt automatisch het type (integer/date/etc.)
 overgeslagen.
 Indien de string "Procedure" bevat wordt automatisch het optionele woord "Set"
 overgeslagen.

 Deze macro heeft problemen met regels die door een ";" worden afgesloten.
 Bijvoorbeeld:

 Procedure ;
 Test3

 wordt niet correct verwerkt. (Test3 verschijnt niet in de lijst.)

 PARAMETERS:

 RETURNS:

*****************************09-23-91 03:28pm*******************************/

str DTFindTag(
		int Tag			= Parse_Int( "/TAG=", MParm_Str ),
		int SrchFwd	= Parse_Int( "/F=", MParm_Str ),
		str ParmStr	= MParm_Str
		) trans2
/******************************************************************************
															 Multi-Edit Macro
															 09-Jan-97  17:30

  Function: Scans for DataFlex funtions.
	Entry   : int tag       - When TRUE will scan and tag functions, else
														will return the next/previous function.     (/TAG=)
						int srchFwd   - TRUE to search for next function else search for
														previous function														(/F=)
						str parmStr   - Additional parameters

	Exit    : str ( return_str )  The found function name
	Author  : Dan Hughes

							 Copyright (C) 1997 by American Cybernectics, Inc.
 *******************************************************************( ldh )***/
{
	int SavRefresh = Refresh;
	int SrchDir 	 = _backward;
	int Found;

	str	TStr;
	str	Object[ 40 ];
	str	TagId[ 100 ];
  str sFind[ Max_Line_Length ];
  str sTags[ Max_Line_Length ];
  int ix;

	Refresh = false;

  if ( Tag ) sTags = gsTagKeywords;
  else       sTags = gsEOLAutoFillTags;

  sFind = gsDFTAGStartOfLine + sTags + gsDFTAGEnd;
  sTags = ReTranslate( sTags, 1 );
  sFind = ReTranslate( sFind, 1 );

	if ( Tag ) {
		Tof;
		SrchDir = 0;
		while ( true ) {
			call Do_Search;
			if ( Found ) {
				TagShowProgress( C_Line );
				TagAddTag( TagId, Object, TStr );
				Eol;
			}
			else {
				break;
			}
		}
	}
	else {
		if ( SrchFwd ) {
			SrchDir = 0;
		}
		call Do_Search;
	}
	Refresh = SavRefresh;
	return ( Return_Str = TagId );


	// **** Internal routines ****

Do_Search:
  if ( Found = Find_Text( sFind, 0, SrchDir | _regExp ) ) {
    
    // -------------------------------------------------------------------
    // We use Find_Text again to skip [] or #$ etc.
    // 
    Find_Text( sTags, 1, _regExp );
		TStr = Copy( Get_Line( ), C_Col, 255 );
    
    Object = Get_Word( gsDFEndOfWord );
    
    Forward_Till    ( gsDFEndOfWord );
    Forward_Till_Not( gsDFEndOfWord );
    if ( Caps(object) == "PROPERTY" ) // If PROPERTY, skip the type to get name.
    {
      // Property <Type> <variabele>
      Forward_Till    ( gsDFEndOfWord );
      Forward_Till_Not( gsDFEndOfWord );
    }
    TagId = Get_Word( gsDFEndOfWord );
    
    // If PROCEDURE, check to see if it's a PROCEDURE SET and compensate.
    if ( ( Caps(object) == "PROCEDURE" ) && ( Caps(tagid) == "SET" ) )
    {
      // Procedure [Set] <Naam>
      Forward_Till    ( gsDFEndOfWord );
      Forward_Till_Not( gsDFEndOfWord );
      TagId = Get_Word( gsDFEndOfWord );
    }
	}
	ret;

}  // DTFindTag
