macro_file gjwtools;

void LoadVCS( )
/********************************************************************
                                                       Multi-Edit Macro
                                                        15-01-98 11:01

  Function: This routine will close the current window and replace it
            with a window in which the file with the same name is loaded.
            This can be used when a file is loaded from a shadow
            directory of Visual SourceSafe(VSS) and the same file must
            be "get" from VSS.
  Entry   : -
  Exit    : -

***********************************************************************/
{
  str sFilename;

  sFilename = Truncate_Path( File_Name );

  if ( !File_Changed ) {
    Return_Str = sFilename;
    RM( "LDFiles /LC=0" );
    if ( Error_Level ) {
      Make_Message( "An error occured while re-opening the file...");
    }
  }
  else {
    Make_Message( "File has changed, no re-open..." );
  }

}  // LoadVCS

void BewerkDef( )
/********************************************************************
                                                       Multi-Edit Macro
                                                        15-01-98 11:01

  Function: This routine will replace all "variable" text in a DataFlex
            DEF-file with default text, so that text cannot indicate to
            Visual SourceSafe that the file has changed.
  Entry   : -
  Exit    : -

***********************************************************************/
{
  int iOrgInser_Mode = Insert_Mode;
  int iOrgRefresh    = Refresh;
  str sExtension;

  Refresh     = False;
  Insert_Mode = False;

  sExtension = Caps( Get_Extension( File_Name ) );
  if ( sExtension == "DEF" ) {
    Tof;
    if (Find_Text( "DATE:", 14, 0 )) {
        Text( "DATE: 00-00-00" );
    }

    if (Find_Text( "TIME:", 1, 0 )) {
        Text( "TIME: 00:00" );
    }
    if (Find_Text( "MAX NUMBER OF RECORDS", 14, 0 )) {
      if (Find_Text( "USED: [0-9]+", 1, _RegExp  )) {
        Replace( "USED: 0" );
      }
    }
    Tof;
  }
  else {
    Make_Message( "No DEF file...");
  }

  Insert_Mode = iOrgInser_Mode;
  Refresh = iOrgRefresh;

}  // BewerkDef

void LoadPRN( )
/********************************************************************
                                                       Multi-Edit Macro
                                                        01-10-98 16:47

  Function: This routine will load the a file with the same name as the
            current file, except another extension will be used (PRN).

  Entry   : -
  Exit    : -

***********************************************************************/
{
  str sFilename;

  sFilename = Truncate_Extension( Truncate_Path( File_Name ) );

  Return_Str = sFilename + ".PRN";
  RM( "LDFiles /LC=1" );
  if ( Error_Level ) {
    Make_Message( "An error occured while loading the PRN-file...");
  }

}  // LoadPRN
